import java.util.*;
public class NittaF {
    static final int UNKNOWN = -1;
    static final int INFINITE = Integer.MAX_VALUE;
    public static void main(String[] args) {
	Scanner sc = new Scanner(System.in);
	Solver sol = new Solver();
	while (sol.input(sc)) System.out.println(sol.solve());
    }
    static class Solver {
	int[][] tbl;
	int[][] memo;
	ArrayList<String> v;
	public boolean input(Scanner sc) {
	    v = new ArrayList<String>();
	    ArrayList<String> omit = new ArrayList<String>();
	    int n = sc.nextInt();
	    if (n==0) return false;
	    for (int i=0; i<n; i++) {
		String s = sc.next();
		boolean flag=true;
		for (String x: v) {
		    if (x.contains(s)) flag=false;
		    else if (s.contains(x)) omit.add(x);
		}
		if (flag) v.add(s);
	    }
	    for (String s: omit) v.remove(s);
	    return true;
	}
	public static int nMatches(String p,String q) {
	    int k=0;
	    for (int i=1; i<=p.length()&&i<=q.length(); i++)
		if (p.regionMatches(p.length()-i,q,0,i)) k=i;
	    return k;
	}
	int bs2int(BitSet bs) {
	    int x=0;
	    for (int i=0,f=1; i<v.size(); i++,f<<=1)
		if (bs.get(i)) x += f;
	    return x;
	}
	public int solve(BitSet bs,int last) {

	    // [課題] 正しく動作するコードを書きなさい

	    // memo[bsが表す整数値][last] がUNKNOWNでなければその値を返す
	    // bsの第last bitをclearして
	    // bsの中の各set bitについて繰り返し(第iビットとする)
	    //   bsのset bit中で第i番目の文字列が最後の場合の最小文字数
	    //   ＋第i番目の後ろに第last番目の文字列を付加して増える文字数
	    //   の最小値を求める
            // memo[bsが表す整数値][last] にその最小値を入れる
	    // bsを元に戻して (第last bitをsetし直して)
	    // 最小値を返す

	}
	public int solve() {
	    tbl = new int[v.size()][v.size()];
	    for (int i=0; i<v.size(); i++)
		for (int j=0; j<v.size(); j++)
		    tbl[i][j] = nMatches(v.get(i),v.get(j));
	    memo = new int[(int)Math.pow(2,v.size())][v.size()];
	    for (int i=0; i<memo.length; i++)
		for (int j=0; j<memo[i].length; j++)
		    memo[i][j] = UNKNOWN;
	    BitSet bs = new BitSet(v.size());
	    for (int i=0; i<v.size(); i++) {
		bs.clear();
		bs.set(i);
		memo[bs2int(bs)][i] = v.get(i).length();
	    }
	    bs.set(0,v.size());
	    int ans=INFINITE;
	    for (int i=0; i<v.size(); i++) {
		int ret = solve(bs,i);
		if (ret<ans) ans=ret;
	    }
	    return ans;
	}
    }
}
